import java.util.*;

public class WalletTotalsPerCategoryStatisticsTableClass extends CalendarTableClass {
    private static final String TITLE[]       = {"Category", "Totals"};
    private static final int    ALIGN[]       = {CalendarTableClass.ITEM_ALIGN_LEFT,
                                                 CalendarTableClass.ITEM_ALIGN_RIGHT};
    private static final int    FLOAT_COL_NUM = 0;

    private int WalletId;

    public WalletTotalsPerCategoryStatisticsTableClass(Calendar month, int wallet_id, String wallet_name) {
        super(wallet_name, "", month, TITLE, ALIGN, FLOAT_COL_NUM);

        WalletId = wallet_id;

        RefreshData();
    }

    protected void RefreshData() {
        Vector statistics;

        try {
            SetLabel(UtilClass.GetCalendarMonthName(Month) + " " + String.valueOf(Month.get(Calendar.YEAR)) + " : " +
                     UtilClass.MoneyToString(TransactionStorageClass.GetBalanceForWalletIdMonth(WalletId, Month)));
        } catch (Exception ex) {
            SetLabel(UtilClass.GetCalendarMonthName(Month) + " " + String.valueOf(Month.get(Calendar.YEAR)));
        }

        try {
            statistics = TransactionStorageClass.GetTotalsPerCategoryStatisticsForWalletIdMonthSortedByAmount(WalletId, Month);

            Data        = new String[statistics.size()][GetCols()];
            Rows        = Data.length;
            SelectedRow = 0;

            for (int i = 0; i < statistics.size(); i++) {
                WalletTotalsPerCategoryStatisticsItemClass statistics_item  = (WalletTotalsPerCategoryStatisticsItemClass)statistics.elementAt(i);

                Data[i][0] = statistics_item.GetCategoryName();

                if (statistics_item.GetTotals() > 0) {
                    Data[i][1] = "+" + UtilClass.MoneyToString(statistics_item.GetTotals());
                } else {
                    Data[i][1] =       UtilClass.MoneyToString(statistics_item.GetTotals());
                }
            }
        } catch (Exception ex) {
            Data        = new String[0][GetCols()];
            Rows        = Data.length;
            SelectedRow = 0;
        }
    }
}
